#include <iostream>
#include <iomanip>
#include <cstring>
#include <string>
#include <fstream>
#include <boost/thread.hpp>
#include <boost/bind.hpp>
#include <boost/asio.hpp>

using namespace std;
using namespace boost;
using namespace boost::asio;
using ip::tcp;

unsigned short channel;
char *username;
char *command;
char *password;

tcp::iostream * sock;

struct turn
{
	union
	{
		struct
		{
			unsigned short channel;
			short length;
		};
		unsigned char bytes[4];
	};
};
union short2char
{
	struct
	{
		unsigned char u8[2];
	};
	unsigned short u16;
};

unsigned short endian_change( unsigned short val )
{
	short2char uni1, uni2;
	uni1.u16 = val;
	uni2.u8[0] = uni1.u8[1];
	uni2.u8[1] = uni1.u8[0];
	return uni2.u16;
}

void receiving(  )
{
	turn header;
	int length;
	char text[65536];
	int i;
	int mode = 0;

	while( 1 )
	{
		header.length = -1;
		try
		{
			sock->read( reinterpret_cast < char *>( &header ), sizeof ( header ) );
		}
		catch( char *str )
		{
			cout << "Connection closed: " << str << endl;
			break;
		}
		if( header.length == -1 )
		{
			cout << "Connection closed." << endl;
			break;
		}

		if( endian_change( header.length ) )
		{
			sock->read( text, endian_change( header.length ) );
			channel = endian_change( header.channel );
			text[endian_change( header.length )] = 0;
			cout << text << flush;

			do
			{
				if( strstr( text, "username:" ) == text )
				{
					strcpy( text + 4, username );
				}
				else if( strstr( text, "AUTHENTICATE CRAM-MD5." ) == text )
				{
					cout << endl;
					if( password )
						strcpy( text + 4, password );
					else
						strcpy( text + 4, " " );
					// strcpy( text + 4, "AUTHENTICATE CRAM-MD5 OK." );
					mode = 2;
				}
				else if( mode == 2 )
				{
					if( command )
					{
						strcpy( text + 4, command );
						mode = 3;
					}
					else
					{
						cout << endl;
						mode = 4;
						break;
					}
				}
				/* 
				 * else if( mode == 1 ) { char phpcmd[512]; sprintf( phpcmd, "echo \"<?php print base64_encode('%s'.'
				 * '.hash_hmac('md5',base64_decode('%s'),'%s')); ?>\" | php > /tmp/turn.crammd5", username, text,
				 * "password" ); std::system( phpcmd );
				 * 
				 * ifstream ifs( "/tmp/turn.crammd5" ); string cram;
				 * 
				 * ifs >> cram; strcpy( text + 4, cram.c_str() ); cout << endl; mode = 2; } */
				else
				{
					break;
				}

				length = strlen( text + 4 );
				header.length = endian_change( length );
				for ( i = 0; i < 4; i++ )
					text[i] = header.bytes[i];
				sock->write( text, sizeof ( header ) + length );
				sock->flush(  );

				if( mode != 2 )
					cout << ( text + 4 ) << endl << flush;
			}
			while( 0 );
		}
		if( mode == 3 )
		{
			exit( 1 );
		}
	}
}

void sending(  )
{
	int i;
	int length;
	turn header;
	char text[65536];

	while( 1 )
	{
		cin.getline( text + 4, 65532 );
		length = strlen( text + 4 );
		header.length = endian_change( length );
		header.channel = endian_change( channel );
		if( length > 1 )
		{
			for ( i = 0; i < 4; i++ )
				text[i] = header.bytes[i];
			sock->write( text, sizeof ( header ) + length );
			sock->flush(  );
		}
	}
}

int main( int argc, char *argv[] )
{
	if( argc < 2 )
	{
		cerr << "USAGE:" << argv[0] << " [username@]hostip" << endl;
		return 1;
	}

	char *host;
	if( strchr( argv[1], '@' ) )
	{
		host = strchr( argv[1], '@' ) + 1;

		username = new char[strlen( argv[1] )];
		strcpy( username, argv[1] );
		*( strchr( username, '@' ) ) = 0;
	}
	else
	{
		username = new char[10];
		strcpy( username, "anonymous" );
		host = argv[1];
	}
	ip::address addr = ip::address::from_string( host );
	sock = new tcp::iostream( tcp::endpoint( addr, 10001 ) );

	if( strcmp( username, "anonymous" ) == 0 )
	{
		password = NULL;
	}
	else
	{
		char pass[512];

		std::system( "stty -echo" );
		cout << "Password: ";
		cin.getline( pass, 512 );
		password = new char[strlen( pass )];
		strcpy( password, pass );
		std::system( "stty echo" );
	}

	if( argc > 2 )
		command = argv[2];
	else
		command = NULL;
	thread thr_sending( &sending );
	receiving(  );

	return 0;
}
